var map = L.map('map').setView([0, 0], 1);

L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
    attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
    maxZoom: 6,
    maxNativeZoom: 6,
}).addTo(map);


const penultimateHops = treeData.children.map(c => {
  return {
    name: c.name,
    hostname: c.hostname,
    location: c.location,
    as: c.as
  }
})


const getMarkerColor = as => {
  const fillColor = colorScale(as)
  return fillColor
}

const fontAwesomeIcon = as => L.divIcon({
  html: `<i class="far fa-dot-circle fa-2x" style="color: ${getMarkerColor(as)}"></i>`,
  iconSize: [10, 10],
  className: 'myDivIcon'
});

var markerGroup = L.layerGroup().addTo(map);

const addMarker = ph => {
  const {probeId, probeIp, probePh, location, as} = ph

  const coloredIcon = fontAwesomeIcon(as)
  L.marker(location, {
    icon: coloredIcon, 
  }).addTo(markerGroup)
    .bindPopup(`
      <span>Probe ID: ${probeId}</span>
      <br/>
      <span>Probe address: ${probeIp}</span>
      <br/>
      <span>Penultimate Hop: ${probePh}</span>
      <br/>
      <span><a href="https://atlas.ripe.net/probes/${probeId}/" target="_blank" rel="noopener noreferrer">View probe details in RIPE Atlas</a></span>
    `)
}

// add markers for all penultimate hops
//let phMarkerList = []
//penultimateHops.forEach(ph => {
  //if (ph.location) {
    //phMarkerList.push(ph)
    //addMarker(ph)
  //}
//})


// polyline WIP
//console.log(phMarkerList)
//let pointA = new L.LatLng(phMarkerList[0].location[0], phMarkerList[0].location[1])
//let pointB = new L.LatLng(phMarkerList[1].location[0], phMarkerList[1].location[1])
//let pointList = [pointA, pointB]
//var firstpolyline = new L.Polyline(pointList, {
    //color: 'red',
    //weight: 3,
    //opacity: 0.5,
    //smoothFactor: 1
//});
//firstpolyline.addTo(map);


svgEl.addEventListener('hover-ph', e => {
  console.log("map caught hover-ph event, data:", e.detail)
  // remove previous markers
  markerGroup.clearLayers();

  const ph = e.detail
  ph.children.forEach(probe => {
    if (probe.location) {
      addMarker({
        location: probe.location,
        as: ph.as,
        probeId: probe.probeId,
        probeIp: probe.name,
        probePh: ph.hostname || ph.name,
      })
    }
  })
})
